"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.collateAllObjects = exports.collateObject = undefined;

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _prop2 = require("ramda/src/prop");

var _prop3 = _interopRequireDefault(_prop2);

var _propEq2 = require("ramda/src/propEq");

var _propEq3 = _interopRequireDefault(_propEq2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _giveScore = require("./giveScore");

var _giveScore2 = _interopRequireDefault(_giveScore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var recursiveGetProject = function recursiveGetProject(projects) {
	var rec = function rec(projectId) {
		if (projectId) {
			var parent = rec(projects[projectId].parent);
			if (parent) {
				return parent + "." + projects[projectId].name;
			} else {
				return projects[projectId].name;
			}
		} else {
			return "";
		}
	};

	return rec;
};

var collateObject = exports.collateObject = function collateObject(state) {
	return function (uuid) {
		return (0, _extends3.default)({}, state.props[uuid], {

			tags: state.tagPairs.filter((0, _propEq3.default)("objId", uuid)).map((0, _prop3.default)("tag")),

			project: state.props[uuid] && state.props[uuid].project && recursiveGetProject(state.projects)(state.props[uuid].project)
		});
	};
};

var collateAllObjects = function collateAllObjects(state) {
	var collateObjectFn = collateObject(state);

	return state.objs.map(function (uuid, id) {
		return (0, _extends3.default)({
			uuid: uuid,
			id: id + 1
		}, collateObjectFn(uuid));
	}).filter(function (_ref) {
		var wait = _ref.wait,
		    done = _ref.done;

		if (done) {
			return false;
		}
		if (wait) {
			return new Date().toISOString() > wait;
		}

		return true;
	}).map(function (_ref2) {
		var start = _ref2.start,
		    stop = _ref2.stop,
		    rest = (0, _objectWithoutProperties3.default)(_ref2, ["start", "stop"]);
		return (0, _extends3.default)({}, rest, !start || start && stop && stop > start ? null : {
			start: start
		});
	}).map(function (todo) {
		return (0, _extends3.default)({}, todo, {
			score: (0, _giveScore2.default)(todo)
		});
	});
};
exports.collateAllObjects = collateAllObjects;