"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _pipe2 = require("ramda/src/pipe");

var _pipe3 = _interopRequireDefault(_pipe2);

var _toDate = require("date-fns/fp/toDate");

var _toDate2 = _interopRequireDefault(_toDate);

var _addDays = require("date-fns/fp/addDays");

var _addDays2 = _interopRequireDefault(_addDays);

var _addWeeks = require("date-fns/fp/addWeeks");

var _addWeeks2 = _interopRequireDefault(_addWeeks);

var _addMonths = require("date-fns/fp/addMonths");

var _addMonths2 = _interopRequireDefault(_addMonths);

var _addYears = require("date-fns/fp/addYears");

var _addYears2 = _interopRequireDefault(_addYears);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createRecurenceActionsMiddleware = function createRecurenceActionsMiddleware(store) {
	return function (next) {
		return function (action) {
			if (action.fromReduxDistributedInitialLoad) {
				next(action);
				return;
			}

			if (action.type === "SET_PROP" && action.prop === "done" && store.getState().props[action.objId].recur) {
				var recur = store.getState().props[action.objId].recur;


				var incrementer = (0, _pipe3.default)(_toDate2.default, {
					d: _addDays2.default,
					w: _addWeeks2.default,
					m: _addMonths2.default,
					y: _addYears2.default
				}[recur.period](recur.n));

				var _arr = ["wait", "due", "start", "stop"];
				for (var _i = 0; _i < _arr.length; _i++) {
					var prop = _arr[_i];
					if (store.getState().props[action.objId][prop]) {
						store.dispatch({
							objId: action.objId,
							prop: prop,
							type: "SET_PROP",
							value: incrementer(store.getState().props[action.objId][prop])
						});
					}
				}
			} else {
				next(action);
			}
		};
	};
};

exports.default = createRecurenceActionsMiddleware;