"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _compose2 = require("ramda/src/compose");

var _compose3 = _interopRequireDefault(_compose2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _collateObjects = require("./collateObjects");

Object.keys(_collateObjects).forEach(function (key) {
	if (key === "default" || key === "__esModule") return;
	Object.defineProperty(exports, key, {
		enumerable: true,
		get: function get() {
			return _collateObjects[key];
		}
	});
});

var _redux = require("redux");

var _reduxDistribute = require("redux-distribute");

var _reduxDistribute2 = _interopRequireDefault(_reduxDistribute);

var _createRecurenceActionsMiddleware = require("./createRecurenceActionsMiddleware");

var _createRecurenceActionsMiddleware2 = _interopRequireDefault(_createRecurenceActionsMiddleware);

var _reducers = require("./reducers");

var reducers = _interopRequireWildcard(_reducers);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var createJecJaskStore = function createJecJaskStore(handlers) {
	var reducer = (0, _redux.combineReducers)((0, _extends3.default)({}, reducers));

	var reduxDistrubteEnhancer = (0, _reduxDistribute2.default)(handlers);

	var window = window || {}; //eslint-disable-line no-use-before-define

	var composeEnhancers = window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__ || _compose3.default;

	var store = (0, _redux.createStore)(reducer, composeEnhancers((0, _redux.applyMiddleware)(_createRecurenceActionsMiddleware2.default), reduxDistrubteEnhancer));

	return store;
};

exports.default = createJecJaskStore;