"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _eqBy2 = require("ramda/src/eqBy");

var _eqBy3 = _interopRequireDefault(_eqBy2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var tagPairs = function tagPairs() {
	var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
	var action = arguments[1];

	switch (action.type) {
		case "REDUX_DISTRIBUTE/PURGE_ALL_STATE":
			return [];

		case "ADD_TAG_TO_OBJ":
			return [].concat((0, _toConsumableArray3.default)(state), [{
				objId: action.objId,
				tag: action.tag
			}]);

		case "REMOVE_TAG_FROM_OBJ":
			return state.filter((0, _eqBy3.default)(function (_ref) {
				var objId = _ref.objId,
				    tag = _ref.tag;
				return objId + tag;
			}));

		default:
			return state;
	}
};

exports.default = tagPairs;